;;;; This gives an example of a rules list to be used with
;;;; validate-xml. Compare to book_example.dtd
;;;;
;;;; Syntax of Ruleset
;;;; RULESET - a list of RULEs
;;;; RULE - a list of length three containing, in order, an ELEMENT_NAME,
;;;;        a list of ATTRIBUTE_RULEs and a list of CHILD_RULEs
;;;; ELEMENT_NAME - a string
;;;; ATTRIBUTE_RULE - a list of length 3 containing, in order, an
;;;;                  ATTRIBUTE_NAME, an ATTRIBUTE_CONTENT_RULE and an
;;;;                  ATTRIBUTE_DEFAULT
;;;; CHILD_RULE - a cons containing, in order, an ELEMENT_NAME and
;;;;              an ELEMENT_FREQUENCY
;;;; ATTRIBUTE_NAME - a string
;;;; ATTRIBUTE_CONTENT_RULE - one of the keyword :ID, the keyword :CDATA
;;;;                          or a list of ATTRIBUTE_VALUEs
;;;; ATTRIBUTE_DEFAULT - one of the keywords :REQUIRED :IMPLIED :FIXED
;;;;                     or :DEFAULT
;;;; ELEMENT_FREQUENCY - one of the keywords :ONE :ANY :ONE-OR-MORE or
;;;;                     :NIL-OR-ONE
;;;; ATTRIBUTE_VALUE - a string



;;; Example DTD Ruleset
(("ExampleBook" nil (("Title" . :one)
		     ("Contents" . :nil-or-one)
		     ("Chapter" . :one-or-more)))
 ("Title" nil ((:pcdata)))
 ("Contents" (("numberstyle" ("numeric" "lower-alpha" "upper-alpha"
			      "lower-roman" "upper-roman") :required)
	      ("heading" :cdata :implied)) nil)
 ("Chapter" (("title" :cdata :implied))
            (("Paragraph" . :any)))
 ("Paragraph" nil ((:pcdata))))


;;; Corresponding example XML as parsed from book_example.xml
;;; Simply pass it along with the above ruleset to validate-xml and
;;; it should return good. Try changing it to be invalid and you should
;;; get corresponding error messages.
("ExampleBook" NIL ("Title" NIL "The Virtues of Lisp")
 ("Contents" (("heading" "Contents Page") ("numberstyle" "numeric")))
 ("Chapter" (("title" "Chapter 1")) ("Paragraph" NIL "Foo Bar Baz Quux"))
 ("Chapter" NIL))
